parse_res() {
  local line=${1%$'\r'}

  case $line in
  +*)
    parse_simple "$line"
    ;;
  -*)
    parse_err "$line"
    ;;
  :*)
    parse_int "$line"
    ;;
  \$*)
    parse_bulk "$line"
    ;;
  \**)
    parse_arr "$line"
    ;;
  *)
    parse_other "$line"
  esac
}

parse_simple() {
  (( lines_left -= 1 ))
  printf '%s\n' "${1:1}"
}

parse_int() {
  (( lines_left -= 1 ))
  printf '(integer) %d\n' "${1:1}"
}

parse_err() {
  (( lines_left -= 1 ))
  printf '(error) %s\n' "${1:1}"
}

parse_bulk() {
  bulk=1
}

parse_arr() {
  lines_left=${1:1}
  arr=1
}

parse_other() {
  (( lines_left -= 1 ))

  if (( arr )); then
    printf '%d) ' "$arr"
    (( arr++ ))
  fi

  if (( bulk )); then
    printf '"'
  fi

  printf %s "$1"

  if (( bulk )); then
    printf '"'
  fi

  printf '\n'
}
